__all__ = ["HTTP","dispatcher"]

from types import FunctionType, MethodType
import satine
from new import instancemethod
import sys

class model(satine.xlist):
    def __save__(self, filename):
        doc = str(self)
        file = open(filename, "w")
        file.write(doc)


        

class grape:
    def __init__(self, sender, address, model):
        self.sender = sender
        self.address = address
        self.model = model
        self.code = 200
        
        self.result = None
        self.init()
                    
    def process(self, message, code, mimetype):
        pass
    
    def reply(self, message, code, mimetype):
        self.result = message, code, mimetype

    def init(self):
        pass
        
class listener(grape):
    def __init__(self, sender, address, model):
        grape.__init__(self, sender, address, model)

        self.handlers = []
        cls = self.__class__
        for key in cls.__dict__:
            if key.find("hnd_") == 0:
                item = cls.__dict__[key]
                if type(item) in (MethodType, FunctionType):
                    if item.__doc__:
#                        seq = satine.dfa(item.__doc__)
                        seq = item.__doc__
                        method = instancemethod(item,self,cls)
                        self.handlers.append((seq, method)) 
    def process(self, message, code, mimetype):
        self.result = message, 404, mimetype
        self.code = code
        self.mimetype = mimetype
        print "before visit"
        message.visit(self.handlers)
#        message.visit([])
#        if message.action == "list":
#            self.hnd_list(message)
#        else:
#            self.hnd_add(message)
            
        print "after visit"
        return self.result

class mailbox(grape):
    def __init__(self, sender, address, model):
        part.__init__(self, sender, address, model)        
        self.input_cond = threading.Condition()
        self.output_cond = threading.Condition()
        self.input = None
        self.output = None

    def process(self, message, code, mimetype):
        self.input_cond.acquire()
        while self.input is not None:
            self.input_cond.notify()
            self.input_cond.wait()
        self.input_cond.notify()
        self.input_cond.release()
        
        self.output_cond.acquire()
        while self.output is None:
            self.output_cond.wait()
        self.output_cond.release()
        return self.output

    def reply(self, result):
        self.output_cond.acquire()
        self.output = result
        self.output_cond.notify()
        self.output_cond.release()

    def shift(self):
        self.input_cond.acquire()
        while self.input is None:
            self.input_cond.notify()
            self.input_cond.wait()
        input = self.input
        self.input = None
        self.input_cond.notify()
        self.input_cond.release()
        return input